.\"	$NetBSD: ttyname.3,v 1.20 2008/01/30 19:24:59 apb Exp $
.\"
.\" Copyright (c) 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)ttyname.3	8.1 (Berkeley) 6/4/93
.\"
.Dd June 25, 2008
.Dt TTYNAME 3
.Os
.Sh NAME
.Nm ttyname ,
.Nm ttyname_r ,
.Nm isatty ,
.Nm ttyslot
.Nd get name of associated terminal (tty) from file descriptor
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In unistd.h
.Ft char *
.Fn ttyname "int fd"
.Ft int
.Fn ttyname_r "int fd" "char *buf" "size_t len"
.Ft int
.Fn isatty "int fd"
.In stdlib.h
.Ft int
.Fn ttyslot
.Sh DESCRIPTION
These functions operate on the system file descriptors for terminal
type devices.
These descriptors are not related to the standard
.Tn I/O
.Dv FILE
typedef, but refer to the special device files found in
.Pa /dev
and named
.Pa /dev/tty Ns Em xx
and for which an entry exists in the initialization file
.Pa /etc/ttys
(see
.Xr ttys 5 ) ,
or for pseudo-terminal devices created in ptyfs and named
.Pa /dev/pts/ Ns Em n .
.Pp
The
.Fn isatty
function
determines if the file descriptor
.Fa fd
refers to a valid terminal type device.
.Pp
The
.Fn ttyname
function gets the related device name of a file descriptor for
which
.Fn isatty
is true.
The
.Fn ttyname_r
is the reentrant version of the above, and it places the results in
.Fa buf .
If there is not enough space to place the results (indicated by
.Fa len ) ,
then it returns an error.
.Pp
The
.Fn ttyslot
function
fetches the current process' control terminal number from the
.Xr ttys 5
file entry.
If the terminal is a pseudo-terminal, and there is no special entry
in the
.Xr ttys 5
file for it, the slot number returned is 1 + (last slot number) +
minor(tty).
This will return a consistent and unique number for each pseudo-terminal
device without requiring one to enumerate all of them in
.Xr ttys 5 .
.Sh IMPLEMENTATION NOTES
As an optimisation, these functions attempt to obtain information about
all devices from the
.Pa /var/run/dev.db
database, if it exists.
If the database exists but is out of date, then these functions
may produce incorrect results.
The database should be updated using the
.Xr dev_mkdb 8
command.
.Sh RETURN VALUES
The
.Fn ttyname
function returns the NUL-terminated name if the device is found and
.Fn isatty
is true; otherwise
a
.Dv NULL
pointer is returned and
.Va errno
is set to indicate the error.
.Pp
The
.Fn ttyname_r
functions returns 0 on success and an error code on failure.
.Pp
The
.Fn isatty
function returns 1 if
.Fa fd
is associated with a terminal device; otherwise it returns 0 and
.Va errno
is set to indicate the error.
.Pp
The
.Fn ttyslot
function
returns the unit number of the device file if found; otherwise
the value zero is returned.
.Sh FILES
.Bl -tag -width /etc/ttys -compact
.It Pa /dev/\(**
.It Pa /etc/ttys
.El
.Sh ERRORS
The
.Fn ttyname ,
.Fn ttyname_r ,
and
.Fn isatty
functions will fail if:
.Bl -tag -width Er
.It Bq Er EBADF
The
.Fa fd
argument is not a valid file descriptor.
.It Bq Er ENOTTY
The
.Fa fd
argument does not refer to a terminal device.
.El
.Pp
The
.Fn ttyname_r
function will also fail if:
.Bl -tag -width Er
.It Bq Er ERANGE
The buffer provided is not large enough to fit the result.
.It Bq Er ENOENT
The terminal device is not found.
This can happen if the device node has been removed after it was opened.
.El
.Sh SEE ALSO
.Xr ioctl 2 ,
.Xr ttys 5 ,
.Xr dev_mkdb 8
.Sh STANDARDS
The
.Fn ttyname
and
.Fn isatty
functions conform to
.St -p1003.1-90 .
.Sh HISTORY
.Fn isatty ,
.Fn ttyname ,
and
.Fn ttyslot
functions appeared in
.At v7 .
.\" Use of the .Pa /var/run/dev.db file was added in ???.
.Sh BUGS
The
.Fn ttyname
function leaves its result in an internal static object and returns
a pointer to that object.
Subsequent calls to
.Fn ttyname
will modify the same object.
